C--------------------------------------------------------------------
C  Copyright (C) 2004,  Space Science and Engineering Center,
C  University C  of Wisconsin-Madison, Madison WI.
C
C  This program is free software; you can redistribute it
C  and/or modify it under the terms of the GNU General
C  Public License as published by the Free Software Foundation;
C  either version 2 of the License, or (at your option) any
C  later version.
C
C  This program is distributed in the hope that it will be
C  useful, but WITHOUT ANY WARRANTY; without even the implied
C  warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
C  See the  GNU General Public License for more details.
C
C  You should have received a copy of the GNU General Public
C  License along with this program; if not, write to the Free
C  Software Foundation, Inc., 59 Temple Place, Suite 330,
C  Boston, MA  02111-1307 USA
C--------------------------------------------------------------------
C
      subroutine bt2rad(nchan,freq,bt,radiance)
!
!
!
      implicit none
      
      
      integer i,nchan
      real h,k,c1,c2,c
      parameter(h = 6.6260755E-34) ! Planck constant in Js
      parameter(k = 1.380658E-23)  ! Boltzmann constant in J/K
      parameter(c = 2.99792458E8)  ! photon speed in m/s
      real a,b,bt(nchan),freq(nchan),radiance(nchan)


      c1 = 2*h*c*c*1e8
      c2 = h*c/k*1e2

      do i=1,nchan
        if (bt(i) .le. 0) then
	  write(*,*) 'Warning: BT input negative'
	endif
       a=1e3*c1*(freq(i)*freq(i)*freq(i))
       b=exp((c2*freq(i))/bt(i))-1
       radiance(i)=a/b
      enddo
      
      
      end
      
