C--------------------------------------------------------------------
C  Copyright (C) 2004,  Space Science and Engineering Center,
C  University C  of Wisconsin-Madison, Madison WI.
C
C  This program is free software; you can redistribute it
C  and/or modify it under the terms of the GNU General
C  Public License as published by the Free Software Foundation;
C  either version 2 of the License, or (at your option) any
C  later version.
C
C  This program is distributed in the hope that it will be
C  useful, but WITHOUT ANY WARRANTY; without even the implied
C  warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
C  See the  GNU General Public License for more details.
C
C  You should have received a copy of the GNU General Public
C  License along with this program; if not, write to the Free
C  Software Foundation, Inc., 59 Temple Place, Suite 330,
C  Boston, MA  02111-1307 USA
C--------------------------------------------------------------------
C
        Function LITBIG(jdum)
c
*     21 Sep 99; NSC
*     To test Little or Big Endian-ness of current platform:

c     Function Return:  0=Little,   1=Big
*
        Integer*2 i1
        equivalence(j1,i1)
c     xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
        jj = jdum
        j1 = 1
        litbig = 1 - i1
        return
        end

c     xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
        Function BIGLIT(arg,corig)
c
c     29 Jan 02;  biglit.c also exists.
c
c     This Fortran-callable function performs an end-to-end
c     flip of the given argument, IF NECESSARY, to convert
c     a real data word from Big-Endian to Little Endian, or vice-
c     versa, after testing the current platform for conformity
c     with the platform originating the data word, i.e.
c     corig = 'B' or 'L' for Big- or Little-Endian
c
        data jtest/-1/
        character*1 corig,cx(4),ch
        character*4 carg
        Integer*2 i1
c
        equivalence(j1,i1),(aa,carg),(cx(1),carg)
        save
c     xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
        if(jtest .lt. 0) then
        j1 = 1
        jtest = 1 - i1
        end if
c
        aa = arg
c     This also defines carg.
c
c     Test to see if a flip is needed:
        if((jtest.eq.1.and.corig.eq.'L').or.(jtest.eq.0.and.corig.eq.'B'
     +   ))then
         ch = cx(1)
         cx(1) = cx(4)
         cx(4) = ch
         ch = cx(2)
         cx(2) = cx(3)
         cx(3) = ch
        end if
c
        biglit = aa
        return
        end

