!--------------------------------------------------------------------
!  Copyright (C) 2004,  Space Science and Engineering Center,
!  University C  of Wisconsin-Madison, Madison WI.
!
!  This program is free software; you can redistribute it
!  and/or modify it under the terms of the GNU General
!  Public License as published by the Free Software Foundation;
!  either version 2 of the License, or (at your option) any
!  later version.
!
!  This program is distributed in the hope that it will be
!  useful, but WITHOUT ANY WARRANTY; without even the implied
!  warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
!  See the  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public
!  License along with this program; if not, write to the Free
!  Software Foundation, Inc., 59 Temple Place, Suite 330,
!  Boston, MA  02111-1307 USA
!--------------------------------------------------------------------
!      PROGRAM main_rtv_class_scang.f90
!  
!     EW, Oct-2003
!
!*********************************************************************
!     Routines called:
!                   TPRECW_NEW2
!                   TOTAL_OZONE
!                   RAD2BT
!
!*********************************************************************
      use mod_param
      implicit none
      
      
        integer nchs1,nlevs1,npc,nemis,i,j,k,l,ii,jj
	integer nsamps,nlines,nbands,eof,numang
        parameter(nlevs1=335,nemis=15,numang=11)
        parameter(nsamps=90,nlines=135)
	parameter(nbands=2+nlevs*3+2+nemis*2)
	real*4 dum(3),plevs(nlevs)
	real*4 x_mean(nlevs1)
	real*4 x(nprofs,nlevs1),bt
	real*4 scang(nsamps,nlines)
	real*4 tpw,totoz,tpw1(nprofs),totoz1(nprofs)
	real*4 angs(numang)
	real*4 x1(nlevs1),x2(nlevs1)
	real*4 satang,satang1,satang2,seca,seca1,seca2,xx,sang
	integer mloc(1),cloc(1),count1,count2
	integer IOIN,IOOUT,ierr
	character*1 nodetype
	integer y2a,y2b,y3a,y3b,y4a,y4b
	integer t1(3),t2(3),tpc1,s,m,n,sidx(1)
        integer test
	character*100 fn,infile1,infile2,infile3,infile4
	character*100 infile5,infile6
	character*100 infile2a,infile3a,infile4a
	character*100 hdrfile,outfile,chanfile
	integer, dimension(:),allocatable:: idx
	real, dimension(:,:,:),allocatable:: y_obs, y_obs1
	real, dimension(:),allocatable:: y_mean, dy,wvnr
	real, dimension(:,:),allocatable:: pc,pc1
	real, dimension(:,:),allocatable:: rgc
	real, dimension(:),allocatable:: p
	real*4 dat(nsamps*nlines*nbands)
!	
	DATA IOIN/11/
	DATA IOOUT/12/
	
!....data statements   (pressure levels)
      data plevs/0.0050,0.0161,0.0384,0.0769,0.1370,0.2244, &
     &  0.3454,0.5064,0.7140,0.9753,1.2972,1.6872,2.1526, &
     &  2.7009,3.3398,4.0770,4.9204,5.8776,6.9567,8.1655, &
     &  9.5119,11.0038,12.6492,14.4559,16.4318,18.5847, &
     &  20.9224,23.4526,26.1829,29.1210,32.2744,35.6505, &
     &  39.2566,43.1001,47.1882,51.5278,56.1260,60.9895, &
     &  66.1253,71.5398,77.2396,83.2310,89.5204,96.1138, &
     &  103.0172,110.2366,117.7775,125.6456,133.8462, &
     &  142.3848,151.2664,160.4959,170.0784,180.0183, &
     &  190.3203,200.9887,212.0277,223.4415,235.2338, &
     &  247.4085,259.9691,272.9191,286.2617,300.0000, &
     &  314.1369,328.6753,343.6176,358.9665,374.7241, &
     &  390.8926,407.4738,424.4698,441.8819,459.7118, &
     &  477.9607,496.6298,515.7200,535.2322,555.1669, &
     &  575.5248,596.3062,617.5112,639.1398,661.1920, &
     &  683.6673,706.5654,729.8857,753.6275,777.7897, &
     &  802.3714,827.3713,852.7880,878.6201,904.8659, &
     &  931.5236,958.5911,986.0666,1013.9476,1042.2319, &
     &  1070.9170,1100.0000/
     
 !  11 angles (corresp. sec=1,1+d,1+2d,...1+10d, with d=0.05243)  
      data angs/0.0000,18.1615,25.1643,30.2213,34.2451,37.5991, &
     &  40.4741,42.9857,45.2106,47.2026,49.0015/ 
      
!        data secangs/1.0,1.0524,1.1049,1.1573,1.2097,1.2622, &
!     &  1.3146,1.3670,1.4194,1.4719,1.5243/  
	
!	
!  (1) read Yobs,Ymean,Xmean,RGCoeffs,PCs
!  (2) compute dy=Yobs-Ymean
!  (3) calculate X=Xmean+RGC*(dY*PCs)	
!	
! 

      Call itime (t1)
!
      read (*,'(A)') chanfile
      read (*,'(A)') infile1   !radiances
      read (*,'(A)') infile2   !traingset mean
      read (*,'(A)') infile3   !regression coeffs
      read (*,'(A)') infile4   !eigenvectors (PCs)
      read (*,'(A)') infile5   !scanning angles
      read (*,'(A)') infile6   !nodetype
      read (*,'(A)') hdrfile
      read (*,'(A)') outfile
      read (*,*) npc
     
!
!
! Read good channel indices
!      
      open(UNIT=IOIN,FILE=chanfile)
      i=0
      eof=1
      do while (.TRUE.) 
         read(IOIN,*,iostat=eof) dum
	if (eof .GE. 0) then
	   i=i+1
	else
	   exit
	endif
      enddo
      close(IOIN) 
      nchs1=i
!    
      allocate(idx(1:nchs1))
      allocate(wvnr(1:nchs1))
      open(UNIT=IOIN,FILE=chanfile)
      do i=1,nchs1 
         read(IOIN,*) dum
	  wvnr(i)=dum(2)
	  idx(i)=dum(3)
      enddo
      close(IOIN) 
      write(*,*) 'NCHAN=',nchs1 
!
! allocate variables
!      
   
       allocate(y_obs(nchs1,nsamps,nlines))
       allocate (y_obs1(nchs,nsamps,nlines))
       allocate(y_mean(nchs1))
       allocate(dy(nchs1))
       allocate(pc(nchs1,npc))
       allocate(pc1(nchs1,200))
       allocate(rgc(nlevs1,npc))
       allocate(p(npc))  

!      
! Read in true AIRS measurements 
!
      open(IOIN,FILE=infile1,ACCESS='DIRECT',RECL=((nprofs*nchs)*4),&
     &  IOSTAT=ierr)	
       if(ierr .ne. 0) then
        write(6,'(a,i5,a)') 'Error ',ierr,' opening  file:'
        write(6,*) infile1
        stop
       endif
       read(IOIN,REC=1) y_obs1  !dimension: 2378x90x135
       close(IOIN)
       y_obs=y_obs1(idx(1:nchs1),1:nsamps,1:nlines)
!       deallocate(y_obs1,STAT=test) 
      
! Read Scanning angles
       open(IOIN,FILE=infile5,ACCESS='DIRECT',RECL=(nprofs*4),&
     &  IOSTAT=ierr)
       if(ierr .ne. 0) then
        write(6,'(a,i5,a)') 'Error ',ierr,' opening  file:'
        write(6,*) infile4
        stop
       endif
      read(IOIN,REC=1) scang  !dimension: 90x135
      close(IOIN)
      
!
! perform regression retrieval
!
     
      infile2a=infile2
      infile3a=infile3
      infile4a=infile4
      
      y2a=index(infile2,'X')
      y3a=index(infile3,'X')
      y4a=index(infile4,'X')
 
!      
! get channelindex of 1000 cm-1      
       cloc=minloc(abs(wvnr-1000.0))
     
      count2=0  
      i=0
      do l=1,135
       do k=1,90
	i=i+1
	if (mod(i,1000).eq.0) then
		write(*,*) 'Processed ', i, 'pixels...'
	endif
  	
	!check for bad values
	count1=0
	do j=1,nchs1
	  if (y_obs(j,k,l) .lt. -1) then
	    count1=count1+1
	  endif
	enddo
	!
	if (count1 .gt. 0) then
	  x(i,:)=-9999.0
	  tpw1(i)=-9999.0
	  totoz1(i)=-9999.0
	  write(*,*) i,' Bad Pixel'
	   count2=count2 + 1
	else !continue retrieval
	
!       write(*,*) i

! get classindex	
	call rad2bt(1,wvnr(cloc),y_obs(cloc,k,l),bt)
	
	if (bt .le. 255) j=1
	if ((bt .gt. 255).and.(bt .le. 265)) j=2
	if ((bt .gt. 265).and.(bt .le. 275)) j=3
	if ((bt .gt. 275).and.(bt .le. 285)) j=4
	if ((bt .gt. 285).and.(bt .le. 295)) j=5
	if (bt .gt. 295) j=6
!
      infile2a=infile2
      infile3a=infile3
      infile4a=infile4
!      	
      write(infile2a(y2a:y2a),'(i1)') j
      write(infile3a(y3a:y3a),'(i1)') j
      write(infile4a(y4a:y4a),'(i1)') j
!
! get scanning angle index

      satang=abs(scang(k,l))
      satang1 = angs(1)
      satang2 = angs(numang)

      do ii = 2, numang
	if(satang.lt.angs(ii).and.satang.ge.angs(ii-1)) then
	satang1 = angs(ii-1)
	satang2 = angs(ii)
	go to 8888
	endif
      end do

	if(satang.le.angs(1)) then
	  satang1=angs(1)
	  satang2=angs(1)
	endif

	if(satang.ge.angs(numang)) then
	  satang1=angs(numang)
	  satang2=angs(numang)
	endif

8888	continue

       seca1 = 1.0/cos(3.14159*satang1/180.0)
       seca2 = 1.0/cos(3.14159*satang2/180.0)
       seca = 1.0/cos(3.14159*satang/180.0)
       
       do j=1,2
!
      y2b=index(infile2,'?')
      y3b=index(infile3,'?')
      y4b=index(infile4,'?')
      
      if (j .eq. 1) then
       sang=satang1
      else
       sang=satang2
      endif
      
      ! write(*,'(a,i6,a,f8.2)') 'Profile=',k,', scanang=',scang(k)
      
      sidx=minloc(abs(angs-abs(sang)))
      
      ! write(*,'(a,f8.2,a,i2)') 'nearest angs=',angs(sidx),' sidx=',sidx(1)
      	      
      if (sidx(1) .lt. 10) then
         write(infile2a(y2b:y2b),'(i1)') sidx
	write(infile3a(y3b:y3b),'(i1)') sidx
	write(infile4a(y4b:y4b),'(i1)') sidx
      else
        write(infile2a(y2b:y2b+1),'(i2)') sidx
	write(infile2a(y2b+2:y2b+5),'(a)') '.dat'
	write(infile3a(y3b:y3b+1),'(i2)') sidx
	write(infile3a(y3b+2:y3b+5),'(a)') '.dat'
	write(infile4a(y4b:y4b+1),'(i2)') sidx
	write(infile4a(y4b+2:y4b+5),'(a)') '.dat'
      endif

  !
! Read in Mean of training radiance and profiles
! 
       
      open(IOIN,FILE=infile2a)
      do ii=1,nchs1
         read(IOIN,*) y_mean(ii)
      enddo
      do ii=1,nlevs1
         read(IOIN,*) x_mean(ii)
      enddo
      close(IOIN)

!      
! Read in RG-coefficients
!
      
      open(IOIN,FILE=infile3a,ACCESS='DIRECT',RECL=((nlevs1*npc)*4), &
       IOSTAT=ierr)	
       if(ierr .ne. 0) then
        write(6,'(a,i5,a)') 'Error ',ierr,' opening  file:'
        write(6,*) infile3a
        stop
       endif
      read(IOIN,REC=1) rgc
      close(IOIN)
!      
! Read in PCs
!
  
      open(IOIN,FILE=infile4a,ACCESS='DIRECT',RECL=((nchs1*200)*4), &
       IOSTAT=ierr)	
       if(ierr .ne. 0) then
        write(6,'(a,i5,a)') 'Error ',ierr,' opening  file:'
        write(6,*) infile4a
        stop
       endif
      read(IOIN,REC=1) pc1
      close(IOIN)
      pc=pc1(1:nchs1,1:npc)
!      
!     
!
        dy = y_obs(:,k,l)-y_mean
        p = matmul(dy,pc)
	if (j .eq. 1) then
	x1= x_mean + matmul(rgc,p)
	else
	x2= x_mean + matmul(rgc,p)
	endif
	
      enddo !j-loop
      
        if(seca2.eq.seca1) then
		xx = 0.0
        else
        	xx = (seca-seca1)/(seca2-seca1)
        endif
	
	x(i,1:101)=x1(1:101) + xx*(x2(1:101)-x1(1:101))
	x(i,102:202)=x1(102:202) + xx*(x2(102:202)-x1(102:202))
	x(i,203:303)=x1(203:303) + xx*(x2(203:303)-x1(203:303))
	x(i,304)=x1(304) + xx*(x2(304)-x1(304))
	x(i,305:305+nemis*2)=x1(305:305+nemis*2) + xx*(x2(305:305+nemis*2)-x1(305:305+nemis*2))

!
! compute total preciptable water and total ozone
!
  	
	mloc=minloc(abs(plevs-x(i,305)))
        x(i,102:202)=exp(x(i,102:202))
	
        Call TPRECW_NEW2(plevs, x(i,102:202), tpw, nlevs, mloc, x(i,305))
        Call TOTAL_OZONE(plevs, x(i,203:303), nlevs, mloc, totoz)
        tpw1(i)=tpw
        totoz1(i)=totoz
	
	endif 
	
        enddo  !end k-loop
       enddo  !end l-loop 
       
       write(*,'(a,i5)') 'Number of bad pixels:',count2 
       
       
!
! Open and write to outputfile
!
!  write header file
!      
       call write_hdr(hdrfile,nsamps,nlines,nbands,nemis,nlevs)
!
! create dat-vector
!   
      open(IOIN,FILE=infile6,form='formatted')
      read(IOIN,'(a)') nodetype
      close(IOIN)
      
      if (nodetype .eq. 'A') then  
        write(*,'(a)') 'Ascending granule'
      else
	write(*,'(a)') 'Descending granule'
      endif 
!      
      m=1
      n=nsamps
      do i=1,nlines
        j=(i-1)*nsamps+1
	k=nsamps*i
	!
	! psurf
	dat(m:n)=x(j:k,305)
	m=m+nsamps
	n=n+nsamps
	! tsurf
	dat(m:n)=x(j:k,304)
	m=m+nsamps
	n=n+nsamps
	! rtv temp (lev1-lev101)
	do l=1,nlevs
	    dat(m:n)=x(j:k,l)
	    m=m+nsamps
	    n=n+nsamps
	enddo
	!tpw
	dat(m:n)=tpw1(j:k)
	m=m+nsamps
	n=n+nsamps
	! rtv humidity (lev1-lev101)
	do l=1,nlevs
	    dat(m:n)=x(j:k,101+l)
	    m=m+nsamps
	    n=n+nsamps
	enddo
	!total ozone
	dat(m:n)=totoz1(j:k)
	m=m+nsamps
	n=n+nsamps
	! rtv ozone (lev1-lev101)
	do l=1,nlevs
	    dat(m:n)=x(j:k,202+l)
	    m=m+nsamps
	    n=n+nsamps
	enddo
	! rtv emiss (1-nemis)
	do l=1,nemis
	    dat(m:n)=x(j:k,305+l)
	    m=m+nsamps
	    n=n+nsamps
	enddo
	! rtv rho (1-nemis)
	do l=1,nemis
	    dat(m:n)=x(j:k,305+nemis+l)
	    m=m+nsamps
	    n=n+nsamps
	enddo
      enddo !end i-loop
!
!
!      
      open(IOOUT,FILE=outfile,access='direct',recl=(nsamps*nlines*nbands)*4,&
          form='unformatted')
      write(IOOUT,rec=1) dat
      close(IOOUT)
!      
      Call itime (t2)
      tpc1=(t2(1)*3600+t2(2)*60+t2(3))-(t1(1)*3600+t1(2)*60+t1(3))
      write(*,'(a,i6,a)') 'Code finished after',tpc1,' seconds'
!
!
!   	
       END  
