C--------------------------------------------------------------------
C  Copyright (C) 2004,  Space Science and Engineering Center,
C  University C  of Wisconsin-Madison, Madison WI.
C
C  This program is free software; you can redistribute it
C  and/or modify it under the terms of the GNU General
C  Public License as published by the Free Software Foundation;
C  either version 2 of the License, or (at your option) any
C  later version.
C
C  This program is distributed in the hope that it will be
C  useful, but WITHOUT ANY WARRANTY; without even the implied
C  warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
C  See the  GNU General Public License for more details.
C
C  You should have received a copy of the GNU General Public
C  License along with this program; if not, write to the Free
C  Software Foundation, Inc., 59 Temple Place, Suite 330,
C  Boston, MA  02111-1307 USA
C--------------------------------------------------------------------
C
      subroutine write_hdr(fn,nsamps,nlines,nbands,nemis,nl)
!
! write header file
! 
        implicit none


	integer*4  nl, nemis, nsamps,nlines,nbands
	integer*4 IOOUT, i, j
	character fn*100,ifmt*2,fmt*50,fmt0*50
	DATA IOOUT/12/
C
C 
C   
      open(IOOUT,FILE=fn,form='formatted')  
      write(IOOUT,'(a)') 'ENVI'
      write(IOOUT,'(a)') 
     & 'description = {AIRS ATMOSPHERIC PROFILES PRODUCT}'
      write(IOOUT,'(a,i5)') 'samples =',nsamps
      write(IOOUT,'(a,i5)') 'lines =',nlines
      write(IOOUT,'(a,i5)') 'bands =',nbands
      write(IOOUT,'(a)') 'data type = 4'
      write(IOOUT,'(a)') 'header offset = 0'
      write(IOOUT,'(a)') 'interleave = bil'
      write(IOOUT,'(a)') 'byte order = 0'
      write(IOOUT,'(a)') 'band names = {'
      write(IOOUT,'(a)') 'band   1: Surface_Pressure,'
      write(IOOUT,'(a)') 'band   2: Surface_Skin_Temperature,'
      !temp
      do j=1,nl
      fmt='(a4,i4,a35,'//ifmt(j)//',a1)'
       write(IOOUT,fmt) 'band',2+j,
     & ': Retrieved_Temperature_Profile_Lev',j,','
      enddo
      !tpw [cm]
      write(IOOUT,'(a4,i4,a27)') 'band',2+nl+1,
     &  ': Total_Precipitable_Water,'
      !humidity
      do j=1,nl
      fmt='(a4,i4,a32,'//ifmt(j)//',a1)'
       write(IOOUT,fmt) 'band',3+j+nl,
     & ': Retrieved_Humidity_Profile_Lev',j,','
      enddo
      !total ozone
      write(IOOUT,'(a4,i4,a14)') 'band',3+nl*2+1,': Total_Ozone,'
      !ozone
      do j=1,nl
      fmt='(a4,i4,a29,'//ifmt(j)//',a1)'
       write(IOOUT,fmt) 'band',4+j+nl*2,
     & ': Retrieved_Ozone_Profile_Lev',j,','
      enddo
      !surface emissivity
      do j=1,nemis
      fmt='(a4,i4,a27,'//ifmt(j)//',a1)'
       write(IOOUT,fmt) 'band',4+j+nl*3,
     & ': Retrieved_Emissivity_Chan',j,','
      enddo
      !surface reflectivity
      do j=1,nemis
      fmt='(a4,i4,a29,'//ifmt(j)//',a1)'
      fmt0='(a4,i4,a29,'//ifmt(j)//')'
        if (j .eq. nemis) then
	   write(IOOUT,fmt0) 'band',4+j+nl*3+nemis,
     &  ': Retrieved_Reflectivity_Chan',j
   	else
          write(IOOUT,fmt) 'band',4+j+nl*3+nemis,
     &  ': Retrieved_Reflectivity_Chan',j,','
        endif
       enddo
      write(IOOUT,'(a)') '}'
C      
C write corresponding units 
C    
      write(IOOUT,'(a)') 'band units = {'
      write(IOOUT,'(a)') 'band   1: hPa,'
      write(IOOUT,'(a)') 'band   2: K,'
      do j=1,nl
       write(IOOUT,'(a,i4,a)') 'band',2+j,': K,'
      enddo
      write(IOOUT,'(a,i4,a)') 'band',2+nl+1,': cm,'
      do j=1,nl
       write(IOOUT,'(a,i4,a)') 'band',3+j+nl,': g/kg,'
      enddo
      write(IOOUT,'(a,i4,a)') 'band',3+nl*2+1,': dobson,'
      do j=1,nl
       write(IOOUT,'(a,i4,a)') 'band',4+j+nl*2,': ppmv,'
      enddo
      do j=1,nemis
       write(IOOUT,'(a,i4,a)') 'band',4+j+nl*3,': none,'
      enddo
      do j=1,nemis
       if (j .eq. nemis) then
         write(IOOUT,'(a,i4,a)') 'band',4+j+nl*3+nemis,': none'
       else
         write(IOOUT,'(a,i4,a)') 'band',4+j+nl*3+nemis,': none,'
       endif
      enddo
      write(IOOUT,'(a)') '}'
      write(IOOUT,'(a)') 'bad value = -9999.0'
      close(IOOUT)
	    
      END  
      
      character*2 function ifmt(j)
      integer j,k
      k=MAX(1,INT(ALOG10(FLOAT(j))+1.0))
      write(ifmt,'(a1,i1)') 'i',k
      return
      end
